Index: sys/kern/kern_prot.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/kern_prot.c,v
retrieving revision 1.105
diff -u -r1.105 kern_prot.c
--- sys/kern/kern_prot.c	2001/09/20 21:45:31	1.105
+++ sys/kern/kern_prot.c	2001/09/21 12:39:39
@@ -46,12 +46,14 @@
 
 #include "opt_compat.h"
 #include "opt_global.h"
+#include "opt_mac.h"
 
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/acct.h>
 #include <sys/kernel.h>
 #include <sys/lock.h>
+#include <sys/mac.h>
 #include <sys/mutex.h>
 #include <sys/proc.h>
 #include <sys/sysproto.h>
@@ -1365,6 +1367,10 @@
 
 	if ((error = prison_check(u1, u2)))
 		return (error);
+#ifdef MAC
+	if ((error = mac_can(p1->p_ucred, &ps->p_ucred->cr_label, MAC_READ, 0))
+		return (ESRCH);
+#endif
 	if (!ps_showallprocs && u1->cr_ruid != u2->cr_ruid) {
 		if (suser_xxx(u1, NULL, PRISON_ROOT) != 0)
 			return (ESRCH);
@@ -1411,6 +1417,13 @@
 	if ((error = prison_check(p1->p_ucred, p2->p_ucred)))
 		return (error);
 
+#ifdef MAC
+	if (mac_can(p1->p_ucred, &p2->p_ucred->cr_label, MAC_READ, 0))
+		return (ESRCH);
+	if (mac_can(p1->p_ucred, &p2->p_ucred->cr_label, MAC_SIGNAL, 0))
+		return (EPERM);
+#endif		
+
 	/*
 	 * UNIX signalling semantics require that processes in the same
 	 * session always be able to deliver SIGCONT to one another,
@@ -1484,6 +1497,14 @@
 		return (0);
 	if ((error = prison_check(p1->p_ucred, p2->p_ucred)))
 		return (error);
+
+#ifdef MAC
+	if (mac_can(p1->p_ucred, &p2->p_ucred->cr_label, MAC_READ, 0))
+		return (ESRCH);
+	if (mac_can(p1->p_ucred, &p2->p_ucred->cr_label, MAC_WRITE, 0))
+		return (EPERM);
+#endif
+
 	if (p1->p_ucred->cr_ruid == p2->p_ucred->cr_ruid)
 		return (0);
 	if (p1->p_ucred->cr_uid == p2->p_ucred->cr_ruid)
@@ -1529,6 +1550,13 @@
 
 	if ((error = prison_check(p1->p_ucred, p2->p_ucred)))
 		return (error);
+
+#ifdef MAC
+	if (mac_can(p1->p_ucred, &p2->p_ucred->cr_label, MAC_READ, 0))
+		return (ESRCH);
+	if (mac_can(p1->p_ucred, &p2->p_ucred->cr_label, MAC_WRITE, 0))
+		return (EPERM);
+#endif
 
 	/*
 	 * Not owned by you, has done setuid (unless you're root).
Index: sys/kern/subr_mbuf.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/subr_mbuf.c,v
retrieving revision 1.8
diff -u -r1.8 subr_mbuf.c
--- sys/kern/subr_mbuf.c	2001/09/12 08:37:45	1.8
+++ sys/kern/subr_mbuf.c	2001/09/13 22:01:35
@@ -36,6 +36,7 @@
 #include <sys/lock.h>
 #include <sys/mutex.h>
 #include <sys/condvar.h>
+#include <sys/mac.h>
 #include <sys/smp.h>
 #include <sys/kernel.h>
 #include <sys/sysctl.h>
@@ -904,6 +905,9 @@
 		(m)->m_pkthdr.rcvif = NULL;				\
 		(m)->m_pkthdr.csum_flags = 0;				\
 		(m)->m_pkthdr.aux = NULL;				\
+#if MAC
+		mac_init_object(&((m_set)->m_pkthdr.label));		\
+#endif /* MAC */
 	}								\
 } while (0)
 
Index: sys/kern/sys_socket.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/sys_socket.c,v
retrieving revision 1.35
diff -u -r1.35 sys_socket.c
--- sys/kern/sys_socket.c	2001/09/12 08:37:46	1.35
+++ sys/kern/sys_socket.c	2001/09/13 22:01:36
@@ -45,6 +45,7 @@
 #include <sys/stat.h>
 #include <sys/uio.h>
 #include <sys/filedesc.h>
+#include <sys/mac.h>
 #include <sys/ucred.h>
 
 #include <net/if.h>
Index: sys/kern/syscalls.master
===================================================================
RCS file: /home/ncvs/src/sys/kern/syscalls.master,v
retrieving revision 1.97
diff -u -r1.97 syscalls.master
--- sys/kern/syscalls.master	2001/09/18 23:31:36	1.97
+++ sys/kern/syscalls.master	2001/09/19 03:13:40
@@ -544,3 +544,9 @@
 			    const char *attrname); }
 374	MSTD	BSD	{ int __setugid(int flag); }
 375	NOIMPL	BSD	{ int nfsclnt(int flag, caddr_t argp); }
+376	STD	BSD	{ int __mac_get_proc(struct mac *mac_p); }
+377	STD	BSD	{ int __mac_set_proc(struct mac *mac_p); }
+378	STD	BSD	{ int __mac_get_fd(int fd, struct mac *mac_p); }
+379	STD	BSD	{ int __mac_get_file(const char *path_p, struct mac *mac_p); }
+380	STD	BSD	{ int __mac_set_fd(int fd, struct mac *mac_p); }
+381	STD	BSD	{ int __mac_set_file(const char *path_p, struct mac *mac_p); }
Index: sys/kern/vnode_if.src
===================================================================
RCS file: /home/ncvs/src/sys/kern/vnode_if.src,v
retrieving revision 1.43
diff -u -r1.43 vnode_if.src
--- sys/kern/vnode_if.src	2001/09/12 08:37:47	1.43
+++ sys/kern/vnode_if.src	2001/09/13 22:01:38
@@ -551,3 +551,23 @@
 	IN struct vnode *vp;
 	OUT struct vm_object **objpp;
 };
+
+#
+#% getlabel	vp	L L L
+#
+vop_getlabel {
+	IN struct vnode *vp;
+	OUT struct mac *label;
+	IN struct ucred *cred;
+	IN struct proc *p;
+};
+
+#
+#% setlabel	vp	L L L
+#
+vop_setlabel {
+	IN struct vnode *vp;
+	IN struct mac *label;
+	IN struct ucred *cred;
+	IN struct proc *p;
+};
cvs diff: Diffing sys/libkern
cvs diff: Diffing sys/libkern/alpha
cvs diff: Diffing sys/libkern/ia64
cvs diff: Diffing sys/modules
cvs diff: Diffing sys/modules/3dfx
cvs diff: Diffing sys/modules/aac
cvs diff: Diffing sys/modules/accf_data
cvs diff: Diffing sys/modules/accf_http
cvs diff: Diffing sys/modules/acpi
cvs diff: Diffing sys/modules/agp
cvs diff: Diffing sys/modules/aha
cvs diff: Diffing sys/modules/aic
cvs diff: Diffing sys/modules/amr
cvs diff: Diffing sys/modules/an
cvs diff: Diffing sys/modules/ar
cvs diff: Diffing sys/modules/asr
cvs diff: Diffing sys/modules/atspeaker
cvs diff: Diffing sys/modules/aue
cvs diff: Diffing sys/modules/bktr
cvs diff: Diffing sys/modules/bktr/bktr
cvs diff: Diffing sys/modules/bktr/bktr_mem
cvs diff: Diffing sys/modules/cam
cvs diff: Diffing sys/modules/cardbus
cvs diff: Diffing sys/modules/cbb
cvs diff: Diffing sys/modules/ccd
cvs diff: Diffing sys/modules/cd9660
cvs diff: Diffing sys/modules/coda
cvs diff: Diffing sys/modules/coff
cvs diff: Diffing sys/modules/cue
cvs diff: Diffing sys/modules/dc
cvs diff: Diffing sys/modules/de
cvs diff: Diffing sys/modules/digi
cvs diff: Diffing sys/modules/digi/digi
cvs diff: Diffing sys/modules/digi/digi_CX
cvs diff: Diffing sys/modules/digi/digi_CX_PCI
cvs diff: Diffing sys/modules/digi/digi_EPCX
cvs diff: Diffing sys/modules/digi/digi_EPCX_PCI
cvs diff: Diffing sys/modules/digi/digi_Xe
cvs diff: Diffing sys/modules/digi/digi_Xem
cvs diff: Diffing sys/modules/digi/digi_Xr
cvs diff: Diffing sys/modules/ed
cvs diff: Diffing sys/modules/el
cvs diff: Diffing sys/modules/ep
cvs diff: Diffing sys/modules/ext2fs
cvs diff: Diffing sys/modules/fdc
cvs diff: Diffing sys/modules/fdescfs
cvs diff: Diffing sys/modules/fe
cvs diff: Diffing sys/modules/fpu
cvs diff: Diffing sys/modules/fs
cvs diff: Diffing sys/modules/fs/linprocfs
cvs diff: Diffing sys/modules/fs/pseudofs
cvs diff: Diffing sys/modules/fxp
cvs diff: Diffing sys/modules/gnufpu
cvs diff: Diffing sys/modules/hpfs
cvs diff: Diffing sys/modules/ibcs2
cvs diff: Diffing sys/modules/if_disc
cvs diff: Diffing sys/modules/if_ef
cvs diff: Diffing sys/modules/if_gif
cvs diff: Diffing sys/modules/if_ppp
cvs diff: Diffing sys/modules/if_sl
cvs diff: Diffing sys/modules/if_stf
cvs diff: Diffing sys/modules/if_tap
cvs diff: Diffing sys/modules/if_tun
cvs diff: Diffing sys/modules/if_vlan
cvs diff: Diffing sys/modules/ip6fw
cvs diff: Diffing sys/modules/ip_mroute_mod
cvs diff: Diffing sys/modules/ipfilter
cvs diff: Diffing sys/modules/ipfw
cvs diff: Diffing sys/modules/ispfw
cvs diff: Diffing sys/modules/joy
cvs diff: Diffing sys/modules/kue
cvs diff: Diffing sys/modules/lge
cvs diff: Diffing sys/modules/libiconv
cvs diff: Diffing sys/modules/libmchain
cvs diff: Diffing sys/modules/linux
cvs diff: Diffing sys/modules/lnc
cvs diff: Diffing sys/modules/md
cvs diff: Diffing sys/modules/mii
cvs diff: Diffing sys/modules/mlx
cvs diff: Diffing sys/modules/mly
cvs diff: Diffing sys/modules/msdosfs
cvs diff: Diffing sys/modules/ncp
cvs diff: Diffing sys/modules/netgraph
cvs diff: Diffing sys/modules/netgraph/UI
cvs diff: Diffing sys/modules/netgraph/async
cvs diff: Diffing sys/modules/netgraph/bpf
cvs diff: Diffing sys/modules/netgraph/bridge
cvs diff: Diffing sys/modules/netgraph/cisco
cvs diff: Diffing sys/modules/netgraph/echo
cvs diff: Diffing sys/modules/netgraph/eiface
cvs diff: Diffing sys/modules/netgraph/ether
cvs diff: Diffing sys/modules/netgraph/frame_relay
cvs diff: Diffing sys/modules/netgraph/hole
cvs diff: Diffing sys/modules/netgraph/iface
cvs diff: Diffing sys/modules/netgraph/ksocket
cvs diff: Diffing sys/modules/netgraph/lmi
cvs diff: Diffing sys/modules/netgraph/mppc
cvs diff: Diffing sys/modules/netgraph/netgraph
cvs diff: Diffing sys/modules/netgraph/one2many
cvs diff: Diffing sys/modules/netgraph/ppp
cvs diff: Diffing sys/modules/netgraph/pppoe
cvs diff: Diffing sys/modules/netgraph/pptpgre
cvs diff: Diffing sys/modules/netgraph/rfc1490
cvs diff: Diffing sys/modules/netgraph/sample
cvs diff: Diffing sys/modules/netgraph/socket
cvs diff: Diffing sys/modules/netgraph/split
cvs diff: Diffing sys/modules/netgraph/sync_ar
cvs diff: Diffing sys/modules/netgraph/sync_sr
cvs diff: Diffing sys/modules/netgraph/tee
cvs diff: Diffing sys/modules/netgraph/tty
cvs diff: Diffing sys/modules/netgraph/vjc
cvs diff: Diffing sys/modules/nfsclient
cvs diff: Diffing sys/modules/nfsserver
cvs diff: Diffing sys/modules/nge
cvs diff: Diffing sys/modules/nmdm
cvs diff: Diffing sys/modules/ntfs
cvs diff: Diffing sys/modules/nullfs
cvs diff: Diffing sys/modules/nwfs
cvs diff: Diffing sys/modules/oldcard
cvs diff: Diffing sys/modules/oltr
cvs diff: Diffing sys/modules/osf1
cvs diff: Diffing sys/modules/pccard
cvs diff: Diffing sys/modules/pccbb
cvs diff: Diffing sys/modules/pcfclock
cvs diff: Diffing sys/modules/pcic
cvs diff: Diffing sys/modules/pcn
cvs diff: Diffing sys/modules/pecoff
cvs diff: Diffing sys/modules/portalfs
cvs diff: Diffing sys/modules/procfs
Index: sys/modules/procfs/Makefile
===================================================================
RCS file: /home/ncvs/src/sys/modules/procfs/Makefile,v
retrieving revision 1.23
diff -u -r1.23 Makefile
--- sys/modules/procfs/Makefile	2001/05/23 09:42:27	1.23
+++ sys/modules/procfs/Makefile	2001/05/31 14:45:13
@@ -16,7 +16,8 @@
 	procfs_subr.c \
 	procfs_type.c \
 	procfs_vfsops.c \
-	procfs_vnops.c
+	procfs_vnops.c \
+	opt_mac.h
 NOMAN=
 
 .include <bsd.kmod.mk>
cvs diff: Diffing sys/modules/random
cvs diff: Diffing sys/modules/ray
cvs diff: Diffing sys/modules/rl
cvs diff: Diffing sys/modules/rp
cvs diff: Diffing sys/modules/s3
cvs diff: Diffing sys/modules/sf
cvs diff: Diffing sys/modules/sis
cvs diff: Diffing sys/modules/sk
cvs diff: Diffing sys/modules/smbfs
cvs diff: Diffing sys/modules/sn
cvs diff: Diffing sys/modules/snc
cvs diff: Diffing sys/modules/snp
cvs diff: Diffing sys/modules/sound
cvs diff: Diffing sys/modules/sound/driver
cvs diff: Diffing sys/modules/sound/driver/ad1816
cvs diff: Diffing sys/modules/sound/driver/als4000
cvs diff: Diffing sys/modules/sound/driver/cmi
cvs diff: Diffing sys/modules/sound/driver/cs4281
cvs diff: Diffing sys/modules/sound/driver/csa
cvs diff: Diffing sys/modules/sound/driver/csapcm
cvs diff: Diffing sys/modules/sound/driver/driver
cvs diff: Diffing sys/modules/sound/driver/ds1
cvs diff: Diffing sys/modules/sound/driver/emu10k1
cvs diff: Diffing sys/modules/sound/driver/es137x
cvs diff: Diffing sys/modules/sound/driver/es1888
cvs diff: Diffing sys/modules/sound/driver/ess
cvs diff: Diffing sys/modules/sound/driver/fm801
cvs diff: Diffing sys/modules/sound/driver/gusc
cvs diff: Diffing sys/modules/sound/driver/ich
cvs diff: Diffing sys/modules/sound/driver/maestro
cvs diff: Diffing sys/modules/sound/driver/maestro3
cvs diff: Diffing sys/modules/sound/driver/mss
cvs diff: Diffing sys/modules/sound/driver/neomagic
cvs diff: Diffing sys/modules/sound/driver/sb16
cvs diff: Diffing sys/modules/sound/driver/sb8
cvs diff: Diffing sys/modules/sound/driver/sbc
cvs diff: Diffing sys/modules/sound/driver/solo
cvs diff: Diffing sys/modules/sound/driver/t4dwave
cvs diff: Diffing sys/modules/sound/driver/via82c686
cvs diff: Diffing sys/modules/sound/driver/vibes
cvs diff: Diffing sys/modules/sound/pcm
cvs diff: Diffing sys/modules/splash
cvs diff: Diffing sys/modules/splash/bmp
cvs diff: Diffing sys/modules/splash/pcx
cvs diff: Diffing sys/modules/sppp
cvs diff: Diffing sys/modules/sr
cvs diff: Diffing sys/modules/ste
cvs diff: Diffing sys/modules/streams
cvs diff: Diffing sys/modules/svr4
cvs diff: Diffing sys/modules/sym
cvs diff: Diffing sys/modules/syscons
cvs diff: Diffing sys/modules/syscons/apm
cvs diff: Diffing sys/modules/syscons/blank
cvs diff: Diffing sys/modules/syscons/daemon
cvs diff: Diffing sys/modules/syscons/fade
cvs diff: Diffing sys/modules/syscons/fire
cvs diff: Diffing sys/modules/syscons/green
cvs diff: Diffing sys/modules/syscons/logo
cvs diff: Diffing sys/modules/syscons/rain
cvs diff: Diffing sys/modules/syscons/snake
cvs diff: Diffing sys/modules/syscons/star
cvs diff: Diffing sys/modules/syscons/warp
cvs diff: Diffing sys/modules/sysvipc
cvs diff: Diffing sys/modules/sysvipc/sysvmsg
cvs diff: Diffing sys/modules/sysvipc/sysvsem
cvs diff: Diffing sys/modules/sysvipc/sysvshm
cvs diff: Diffing sys/modules/ti
cvs diff: Diffing sys/modules/tl
cvs diff: Diffing sys/modules/twe
cvs diff: Diffing sys/modules/tx
cvs diff: Diffing sys/modules/txp
cvs diff: Diffing sys/modules/udbp
cvs diff: Diffing sys/modules/ugen
cvs diff: Diffing sys/modules/uhid
cvs diff: Diffing sys/modules/ukbd
cvs diff: Diffing sys/modules/ulpt
cvs diff: Diffing sys/modules/umapfs
cvs diff: Diffing sys/modules/umass
cvs diff: Diffing sys/modules/umodem
cvs diff: Diffing sys/modules/ums
cvs diff: Diffing sys/modules/unionfs
cvs diff: Diffing sys/modules/urio
cvs diff: Diffing sys/modules/usb
cvs diff: Diffing sys/modules/uscanner
cvs diff: Diffing sys/modules/vesa
cvs diff: Diffing sys/modules/vinum
cvs diff: Diffing sys/modules/vpo
cvs diff: Diffing sys/modules/vr
cvs diff: Diffing sys/modules/vx
cvs diff: Diffing sys/modules/wb
cvs diff: Diffing sys/modules/wi
cvs diff: Diffing sys/modules/wx
cvs diff: Diffing sys/modules/xl
cvs diff: Diffing sys/net
Index: sys/net/if.c
===================================================================
RCS file: /home/ncvs/src/sys/net/if.c,v
retrieving revision 1.116
diff -u -r1.116 if.c
--- sys/net/if.c	2001/09/18 17:41:42	1.116
+++ sys/net/if.c	2001/09/19 02:39:00
@@ -37,6 +37,7 @@
 #include "opt_compat.h"
 #include "opt_inet6.h"
 #include "opt_inet.h"
+#include "opt_mac.h"
 
 #include <sys/param.h>
 #include <sys/malloc.h>
@@ -51,6 +52,7 @@
 #include <sys/syslog.h>
 #include <sys/sysctl.h>
 #include <sys/jail.h>
+#include <sys/mac.h>
 
 #include <net/if.h>
 #include <net/if_arp.h>
@@ -190,6 +192,13 @@
 	TAILQ_INIT(&ifp->if_prefixhead);
 	TAILQ_INIT(&ifp->if_multiaddrs);
 	getmicrotime(&ifp->if_lastchange);
+
+#ifdef MAC
+	mac_init_object(&ifp->if_label_default);
+	mac_init_object(&ifp->if_label_lower);
+	mac_init_object(&ifp->if_label_upper);
+#endif
+
 	if (if_index >= if_indexlim)
 		if_grow();
 
Index: sys/net/if_atmsubr.c
===================================================================
RCS file: /home/ncvs/src/sys/net/if_atmsubr.c,v
retrieving revision 1.16
diff -u -r1.16 if_atmsubr.c
--- sys/net/if_atmsubr.c	2001/06/15 07:32:25	1.16
+++ sys/net/if_atmsubr.c	2001/08/05 17:04:10
@@ -40,6 +40,7 @@
 
 #include "opt_inet.h"
 #include "opt_inet6.h"
+#include "opt_mac.h"
 #include "opt_natm.h"
 
 #include <sys/param.h>
@@ -233,6 +234,14 @@
 		return;
 	}
 	ifp->if_ibytes += m->m_pkthdr.len;
+
+#ifdef MAC
+	/*
+	 * XXX: Label all ATM packets with the interface default label here.
+	 * Can be relabeled later in the protocol stack if desired.
+	 */
+	m->m_label = ifp->if_label_default;
+#endif
 
 	if (rxhand) {
 #ifdef NATM
Index: sys/net/if_ethersubr.c
===================================================================
RCS file: /home/ncvs/src/sys/net/if_ethersubr.c,v
retrieving revision 1.97
diff -u -r1.97 if_ethersubr.c
--- sys/net/if_ethersubr.c	2001/09/10 01:33:03	1.97
+++ sys/net/if_ethersubr.c	2001/09/13 22:02:26
@@ -39,6 +39,7 @@
 #include "opt_inet6.h"
 #include "opt_ipx.h"
 #include "opt_bdg.h"
+#include "opt_mac.h"
 #include "opt_netgraph.h"
 
 #include <sys/param.h>
@@ -408,6 +409,15 @@
 {
 #ifdef BRIDGE
 	struct ether_header save_eh;
+#endif
+
+#ifdef MAC
+	/*
+	 * XXX: Label all ethernet packets with the interface default
+	 * label here.  Can be relabeled later in the protocol stack if
+	 * desired.
+	 */
+	m->m_pkthdr.label = ifp->if_label_default;
 #endif
 
 	/* Check for a BPF tap */
Index: sys/net/if_fddisubr.c
===================================================================
RCS file: /home/ncvs/src/sys/net/if_fddisubr.c,v
retrieving revision 1.52
diff -u -r1.52 if_fddisubr.c
--- sys/net/if_fddisubr.c	2001/09/06 02:40:29	1.52
+++ sys/net/if_fddisubr.c	2001/09/13 16:25:15
@@ -40,6 +40,7 @@
 #include "opt_inet.h"
 #include "opt_inet6.h"
 #include "opt_ipx.h"
+#include "opt_mac.h"
 
 #include <sys/param.h>
 #include <sys/systm.h>
@@ -377,6 +378,16 @@
 		m_freem(m);
 		return;
 	}
+
+#ifdef MAC
+	/*
+	 * XXX: Label all ethernet packets with the interface default
+	 * label here.  Can be relabeled later in the protocol stack if
+	 * desired.   
+	 */
+        m->m_label = ifp->if_label_default;
+#endif
+
 	getmicrotime(&ifp->if_lastchange);
 	ifp->if_ibytes += m->m_pkthdr.len + sizeof (*fh);
 	if (fh->fddi_dhost[0] & 1) {
Index: sys/net/if_gif.c
===================================================================
RCS file: /home/ncvs/src/sys/net/if_gif.c,v
retrieving revision 1.13
diff -u -r1.13 if_gif.c
--- sys/net/if_gif.c	2001/09/03 20:03:53	1.13
+++ sys/net/if_gif.c	2001/09/13 16:25:15
@@ -442,6 +442,13 @@
 	}
 
 	m->m_pkthdr.rcvif = gifp;
+
+	/*
+	 * XXX: Label all ethernet packets with the interface default
+	 * label here.  Can be relabeled later in the protocol stack if
+	 * desired.   
+	 */
+	 m->m_pkthdr.label = gifp->if_label_default;
 	
 	if (gifp->if_bpf) {
 		/*
Index: sys/net/if_iso88025subr.c
===================================================================
RCS file: /home/ncvs/src/sys/net/if_iso88025subr.c,v
retrieving revision 1.18
diff -u -r1.18 if_iso88025subr.c
--- sys/net/if_iso88025subr.c	2001/09/06 02:40:29	1.18
+++ sys/net/if_iso88025subr.c	2001/09/13 16:25:15
@@ -43,6 +43,7 @@
 #include "opt_inet.h"
 #include "opt_inet6.h"
 #include "opt_ipx.h"
+#include "opt_mac.h"
 
 #include <sys/param.h>
 #include <sys/systm.h>
@@ -420,6 +421,15 @@
 		m_freem(m);
 		return;
 	}
+
+#ifdef MAC
+	/*
+	 * XXX: Label all ethernet packets with the interface default
+	 * label here.  Can be relabeled later in the protocol stack if
+	 * desired.   
+	 */
+	m->m_label = ifp->if_label_default;
+#endif
 
 	getmicrotime(&ifp->if_lastchange);
 	ifp->if_ibytes += m->m_pkthdr.len + sizeof(*th);
Index: sys/net/if_spppsubr.c
===================================================================
RCS file: /home/ncvs/src/sys/net/if_spppsubr.c,v
retrieving revision 1.72
diff -u -r1.72 if_spppsubr.c
--- sys/net/if_spppsubr.c	2001/07/31 07:27:01	1.72
+++ sys/net/if_spppsubr.c	2001/08/05 17:04:12
@@ -26,6 +26,7 @@
 #include "opt_inet.h"
 #include "opt_inet6.h"
 #include "opt_ipx.h"
+#include "opt_mac.h"
 #endif
 
 #ifdef NetBSD1_3
@@ -518,6 +519,15 @@
 		m_freem (m);
 		return;
 	}
+
+#ifdef MAC
+	/*
+	 * XXX: Label all ethernet packets with the interface default
+	 * label here.  Can be relabeled later in the protocol stack if
+	 * desired.   
+	 */
+	m->m_label = ifp->if_label_default;
+#endif
 
 	/* Get PPP header. */
 	h = mtod (m, struct ppp_header*);
Index: sys/net/if_stf.c
===================================================================
RCS file: /home/ncvs/src/sys/net/if_stf.c,v
retrieving revision 1.12
diff -u -r1.12 if_stf.c
--- sys/net/if_stf.c	2001/09/19 00:13:00	1.12
+++ sys/net/if_stf.c	2001/09/19 02:39:02
@@ -279,12 +279,6 @@
 	return (0);
 }
 
-static moduledata_t stf_mod = {
-	"if_stf",
-	stfmodevent,
-	0
-};
-
 DECLARE_MODULE(if_stf, stf_mod, SI_SUB_PSEUDO, SI_ORDER_ANY);
 
 static int
@@ -617,6 +611,13 @@
 		m_freem(m);
 		return;
 	}
+
+	/*
+	 * XXX: Label all ethernet packets with the interface default
+	 * label here.  Can be relabeled later in the protocol stack if
+	 * desired.   
+	 */
+	m->m_label = ifp->if_label_default;
 
 	ip = mtod(m, struct ip *);
 
Index: sys/net/if_var.h
===================================================================
RCS file: /home/ncvs/src/sys/net/if_var.h,v
retrieving revision 1.37
diff -u -r1.37 if_var.h
--- sys/net/if_var.h	2001/09/18 17:41:42	1.37
+++ sys/net/if_var.h	2001/09/19 02:39:03
@@ -73,6 +73,7 @@
 struct	ether_header;
 #endif
 
+#include <sys/mac.h>		/* struct mac */
 #include <sys/queue.h>		/* get TAILQ macros */
 
 #ifdef _KERNEL
@@ -153,6 +154,9 @@
 	struct	ifqueue if_snd;		/* output queue */
 	struct	ifqueue *if_poll_slowq;	/* input queue for slow devices */
 	struct	ifprefixhead if_prefixhead; /* list of prefixes per if */
+	struct	mac if_label_default;	/* default label for incoming packets */
+	struct	mac if_label_lower;	/* lower bound for send/recv */
+	struct	mac if_label_upper;	/* upper bound for send/recv */
 };
 
 typedef void if_init_f_t __P((void *));
cvs diff: Diffing sys/netatalk
cvs diff: Diffing sys/netatm
cvs diff: Diffing sys/netatm/ipatm
cvs diff: Diffing sys/netatm/sigpvc
cvs diff: Diffing sys/netatm/spans
cvs diff: Diffing sys/netatm/uni
cvs diff: Diffing sys/netgraph
cvs diff: Diffing sys/netinet
Index: sys/netinet/ip_fw.c
===================================================================
RCS file: /home/ncvs/src/sys/netinet/ip_fw.c,v
retrieving revision 1.167
diff -u -r1.167 ip_fw.c
--- sys/netinet/ip_fw.c	2001/09/20 13:52:49	1.167
+++ sys/netinet/ip_fw.c	2001/09/21 12:40:37
@@ -42,6 +42,7 @@
 #include <sys/socketvar.h>
 #include <sys/sysctl.h>
 #include <sys/syslog.h>
+#include <sys/mac.h>
 #include <sys/ucred.h>
 #include <net/if.h>
 #include <net/route.h>
cvs diff: Diffing sys/netinet6
cvs diff: Diffing sys/netipx
cvs diff: Diffing sys/netkey
cvs diff: Diffing sys/netnatm
cvs diff: Diffing sys/netncp
cvs diff: Diffing sys/netns
cvs diff: Diffing sys/netsmb
cvs diff: Diffing sys/nfs
cvs diff: Diffing sys/nfsclient
cvs diff: Diffing sys/nfsserver
cvs diff: Diffing sys/pc98
cvs diff: Diffing sys/pc98/apm
cvs diff: Diffing sys/pc98/compile
cvs diff: Diffing sys/pc98/conf
cvs diff: Diffing sys/pc98/i386
cvs diff: Diffing sys/pc98/pc98
cvs diff: Diffing sys/pccard
cvs diff: Diffing sys/pci
cvs diff: Diffing sys/posix4
cvs diff: Diffing sys/powerpc
cvs diff: Diffing sys/powerpc/compile
cvs diff: Diffing sys/powerpc/conf
cvs diff: Diffing sys/powerpc/include
cvs diff: Diffing sys/powerpc/powerpc
cvs diff: Diffing sys/sparc64
cvs diff: Diffing sys/sparc64/compile
cvs diff: Diffing sys/sparc64/conf
cvs diff: Diffing sys/sparc64/include
cvs diff: Diffing sys/sparc64/sparc64
cvs diff: Diffing sys/sys
Index: sys/sys/mac.h
===================================================================
RCS file: mac.h
diff -N mac.h
--- /dev/null	Fri Sep 21 09:00:02 2001
+++ mac.h	Wed Feb  7 14:09:55 2001
@@ -0,0 +1,177 @@
+/*-
+ * Copyright (c) 2000 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $FreeBSD: $
+ */
+/*
+ * Userland/kernel interface for Mandatory Access Control.
+ *
+ * The POSIX.1e implementation page may be reached at:
+ * http://www.trustedbsd.org/
+ */                                                        
+#ifndef _SYS_MAC_H
+#define _SYS_MAC_H
+
+#ifndef _POSIX_MAC
+#define	_POSIX_MAC
+#endif
+
+#define	FREEBSD_MAC_EXTATTR_NAME	"$freebsd.mac"
+
+/*
+ * Structures and constants associated with a Biba Integrity policy.
+ * mac_biba represents a Biba label, with mb_type determining its properties,
+ * and mb_grade represents the hierarchal grade if valid for the current
+ * mb_type.
+ */
+struct mac_biba {
+	u_short	mb_type;
+	u_short	mb_grade;
+};
+#define	MAC_BIBA_TYPE_GRADE	0	/* Hierarchal grade with mb_grade. */
+#define	MAC_BIBA_TYPE_LOW	1	/* Dominated by any
+					 * MAC_BIBA_TYPE_LABEL. */
+#define	MAC_BIBA_TYPE_HIGH	2	/* Dominates any
+					 * MAC_BIBA_TYPE_LABEL. */
+#define	MAC_BIBA_TYPE_EQUAL	3	/* Equivilent to any
+					 * MAC_BIBA_TYPE_LABEL. */
+
+/*
+ * Structures and constants associated with a Multi-Level Security policy.
+ * mac_mls represents an MLS label, with mm_type determining its properties,
+ * and mm_level represents the hierarchal sensitivity level if valid for the
+ * current mm_type.
+ */
+struct mac_mls {
+	u_short	mm_type;
+	u_short	mm_level;
+};
+#define	MAC_MLS_TYPE_LEVEL	0	/* Hierarchal level with mm_level. */
+#define	MAC_MLS_TYPE_LOW	1	/* Dominated by any
+					 * MAC_MLS_TYPE_LABEL. */
+#define	MAC_MLS_TYPE_HIGH	2	/* Dominates any
+					 * MAC_MLS_TYPE_LABEL. */
+#define	MAC_MLS_TYPE_EQUAL	3	/* Equivilent to any
+					 * MAC_MLS_TYPE_LABEL. */
+
+/*
+ * Structures and constants for efficient, scalable non-overlapping system
+ * partitions.
+ * mac_partition represents a partitiong label, with mp_type determining
+ * its properties, and mp_partition representing the partition number for
+ * the current mp_type.
+ */
+struct mac_partition {
+	u_short	mp_type;
+	u_int	mp_partition;
+};
+#define	MAC_PARTITION_TYPE_PARTITION	0	/* Visible/can effect the
+						 * partition identified by
+						 * mp_partition. */
+#define	MAC_PARTITION_TYPE_ALL		1	/* Visible from any partition,
+						 * not modifiable from any
+						 * partition. */
+#define	MAC_PARTITION_TYPE_NONE		2	/* Visible from no partition,
+						 * not modifiable from any
+						 * partition. */
+
+struct mac {
+	struct mac_biba	m_biba;
+	struct mac_mls	m_mls;
+	struct mac_partition	m_partition;
+};
+typedef struct mac	*mac_t;
+
+const struct mac mac_userland_system_high_label;
+
+#ifndef _KERNEL
+
+/*
+ * POSIX.1e functions visible in the application namespace.
+ */
+int	mac_dominate __P((const mac_t labela, const mac_t labelb));
+int	mac_equal __P((const mac_t labela, const mac_t labelb));
+int	mac_free __P((void *buf_p));
+mac_t	mac_from_text __P((const char *text_p));
+mac_t	mac_from_fd __P((int fildes));
+mac_t	mac_get_file __P((const char *path_p));
+mac_t	mac_get_proc __P((void));
+mac_t	mac_glb __P((const mac_t labela, const mac_t labelb));
+mac_t	mac_lub __P((const mac_t labela, const mac_t labelb));
+int	mac_set_fd __P((int fildes, const mac_t label));
+int	mac_set_file __P((const char *path_p, mac_t label));
+int	mac_set_proc __P((const mac_t label));
+ssize_t	mac_size __P((mac_t label));
+char *	mac_to_text __P((const mac_t label, size_t *len_p));
+int	mac_valid __P((const mac_t label));
+
+/*
+ * System calls wrapped by some POSIX.1e functions.
+ */
+int	__mac_get_fd(int fd, struct mac *mac_p);
+int	__mac_get_file(const char *path_p, struct mac *mac_p);
+int	__mac_get_proc(struct mac *mac_p);
+int	__mac_set_fd(int fd, struct mac *mac_p);
+int	__mac_set_file(const char *path_p, struct mac *mac_p);
+int	__mac_set_proc(struct mac *mac_p);
+
+#else /* _KERNEL */
+
+/*
+ * Information flow/operation mask, used as an argument to mac_can().
+ */
+#define	MAC_NONE	0x00000000
+#define	MAC_READ	0x00000001	/* Information flow to subject. */
+#define	MAC_WRITE	0x00000002	/* Information flow to object. */
+#define	MAC_EXEC	0x00000004	/* Execute the object. */
+#define	MAC_ADMIN	0x00000008	/* Administer object attributes. */
+#define	MAC_SIGNAL	0x00000010	/* Signal the object (process). */
+#define	MAC_CREATE	0x00000020	/* Create an object with this label. */
+#define	MAC_STAT	0x00000040	/* Read object attributes. */
+#define	MAC_ALL	(MAC_READ | MAC_WRITE | MAC_EXEC | MAC_ADMIN | MAC_SIGNAL | \
+    MAC_CREATE | MAC_STAT)
+
+/*
+ * Kernel functions to manage and evaluate labels.
+ */
+struct ucred;
+int	mac_can __P((const struct ucred *cred, const struct mac *label,
+	    int operation, int sub_operation));
+int	mac_dominate __P((const struct mac *labela, const struct mac *labelb));
+int	mac_equal __P((const struct mac *labela, const struct mac *labelb));
+void	mac_init_subject __P((struct ucred *cred));
+void	mac_create_subject __P((const struct ucred *cred_parent,
+	    struct ucred *cred_child));
+int	mac_can_setlabel_subject __P((const struct ucred *cred_old,
+	    const struct ucred *cred_new));
+void	mac_init_object __P((struct mac *label));
+void	mac_create_object __P((const struct ucred *cred, struct mac *label));
+int	mac_can_setlabel_object __P((const struct ucred *cred,
+	    const struct mac *label_old, const struct mac *label_new));
+void	mac_print_label __P((const struct mac *label));
+
+#endif /* _KERNEL */
+
+#endif /* !_SYS_MAC_H */
